/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"
#include "configure-trackpoint.h"

GtkWidget *main_window;

char *driver_dir = NULL;

int
main (int argc, char *argv[])
{
  struct stat statBuf;
  FILE *file;
  char tmp[256];

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                      argc, argv,
                      GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                      NULL);

  /* search driver path */
  if (stat("/sys/devices/platform/i8042/serio0/serio2/reach", &statBuf)) {
    if (stat("/sys/devices/platform/i8042/serio1/serio2/reach", &statBuf)) {
      if (stat("/sys/devices/platform/i8042/serio0/reach", &statBuf)) {
	if (stat("/sys/devices/platform/i8042/serio1/reach", &statBuf)) {
	  /* error */
	  /* should I check errorno here? */
	  /* no /sys interface */
	  main_window = create_error_dialog_quit();
	} else {
	  driver_dir = "/sys/devices/platform/i8042/serio1";
	}
      } else {
	driver_dir = "/sys/devices/platform/i8042/serio0";
      }
    } else {
      driver_dir = "/sys/devices/platform/i8042/serio1/serio2";
    }
  } else {
    driver_dir = "/sys/devices/platform/i8042/serio0/serio2";
  }

  if (driver_dir) {
    /* check write permission */
    sprintf(tmp, "%s/reach", driver_dir);
    file = fopen(tmp, "r+");
    if (file == NULL) {
      main_window = create_error_dialog_quit();
      gtk_label_set_text(GTK_LABEL(lookup_widget(main_window, "label1")),
			 "You do not have permissions to configure TrackPoint. Please run this program as root.");
      gtk_window_set_title(GTK_WINDOW(main_window), "Permissons Denied");
    } else {
      main_window = create_main ();
      fclose(file);
    }
  }

  gtk_widget_show (main_window);

  gtk_main ();
  return 0;
}

